package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.CommentService;
import com.gxwebsoft.shop.entity.Comment;
import com.gxwebsoft.shop.param.CommentParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品评价记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-23 21:18:56
 */
@Api(tags = "商品评价记录表管理")
@RestController
@RequestMapping("/api/shop/comment")
public class CommentController extends BaseController {
    @Resource
    private CommentService commentService;

    @PreAuthorize("hasAuthority('shop:comment:list')")
    @OperationLog
    @ApiOperation("分页查询商品评价记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Comment>> page(CommentParam param) {
        PageParam<Comment, CommentParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(commentService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(commentService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:comment:list')")
    @OperationLog
    @ApiOperation("查询全部商品评价记录表")
    @GetMapping()
    public ApiResult<List<Comment>> list(CommentParam param) {
        PageParam<Comment, CommentParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(commentService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(commentService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:comment:list')")
    @OperationLog
    @ApiOperation("根据id查询商品评价记录表")
    @GetMapping("/{id}")
    public ApiResult<Comment> get(@PathVariable("id") Integer id) {
        return success(commentService.getById(id));
        // 使用关联查询
        //return success(commentService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:comment:save')")
    @OperationLog
    @ApiOperation("添加商品评价记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Comment comment) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          comment.setUserId(loginUser.getUserId());
        }
        if (commentService.save(comment)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:comment:update')")
    @OperationLog
    @ApiOperation("修改商品评价记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Comment comment) {
        if (commentService.updateById(comment)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:comment:remove')")
    @OperationLog
    @ApiOperation("删除商品评价记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (commentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:comment:save')")
    @OperationLog
    @ApiOperation("批量添加商品评价记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Comment> list) {
        if (commentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:comment:update')")
    @OperationLog
    @ApiOperation("批量修改商品评价记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Comment> batchParam) {
        if (batchParam.update(commentService, "comment_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:comment:remove')")
    @OperationLog
    @ApiOperation("批量删除商品评价记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (commentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
